//Fait par Andr Boileau (aout 2005)

#declare epaisseurTraits = 1;

#macro uneLumiere(localisation)
light_source
{
  localisation
  color rgb<1,1,1>
}
#end  

#macro unCercle(R,plein)
   #if (plein)
     disc
     {
       <0,0,0>,
       y,
       R
     }
   #else
     torus
     {
       R,
       epaisseurTraits
     }
   #end
#end

#macro couleurFond(rouge,vert,bleu)
  background { rgb<rouge/255,vert/255,bleu/255> }
#end

#macro couleur(rouge,vert,bleu,transparent)
  pigment { rgbt <rouge/255,vert/255,bleu/255,transparent/100> }
#end

#macro unPrisme(P1,P2)
box
{
  P1,P2
}
#end

#macro uneSphere(centre,rayon)
sphere
{
  centre
  rayon
}
#end

#macro unPlan(vecteur,d)
plane
{
  vecteur
  d
}
#end

#macro unCone(P1,rayon1,P2,rayon2,ouvert)
cone
{
  P1,rayon1,
  P2,rayon2
  #if (ouvert)
    open
  #end
}
#end

#macro unCylindre(P1,P2,rayon,ouvert)
object
{
  unCone(P1,rayon,P2,rayon,ouvert)
}
#end

#macro unSegment(P1,P2)
   unCylindre(P1,P2,epaisseurTraits,false)
#end

#macro echelle(Ax,Ay,Az)
   scale <Ax,Ay,Az>
#end

#macro translation(Tx,Ty,Tz)
   translate <Tx,Ty,Tz>
#end

#macro rotation(Rx,Ry,Rz)
  rotate <Rx,Ry,Rz>
#end

#macro intersectionDroitePlan(P1,P2,d,a)
 intersectionDroitePlanAux(P1,P2,<0,d,0>,<-sin(radians(a)),cos(radians(a)),0>)
#end

#macro intersectionDroitePlanAux(P1,P2,Q,N)
 ((P1) - (vdot((P1)-(Q),(N))/vdot((P2)-(P1),(N)))*((P2)-(P1)))
#end


// Macros inutiles, laisses pour compatibilit avec versions antrieures


#macro uneCamera(localisation,pointe)
camera
{
  location localisation
  look_at pointe
}
#end

#macro agrandissement(Ax,Ay,Az)
   scale <Ax,Ay,Az>
#end

#macro translationP(T)
   translate <T.x,T.y,T.z>
#end
